/*
 * Copyright: STEM Loyola
 * Date     : August 2019
 * ID       : 19.08-B1
 * Level    : 1 (Amateur)
 *
 * Task     : Your form two friend, Ali, is currently learning how to solve
 *            quadratic equations. Ali knows that you are learning programming
 *            and has asked you to create a program that he can use to check if
 *            his answers are correct. Both you and Ali know that a quadratic
 *            equation is of the form: a^2 + bx + c = 0 and the value of "a"
 *            cannot be zero. Ali needs the program to input the three numbers
 *            (a, b and c) and produce the solution to the equation i.e. the
 *            value(s) of x that makes the equation zero.
 *
 *            In general, the two values of x that solve the equation can be
 *            computed as shown in Figure 1.
 *
 *            Note: (1) When b^2 < 4ac, the equation does not have real
 *                      solutions and your program should just say
 *                      "No Real Solutions".
 *                  (2) If a = 0, your program should just say
 *                      "The value of 'a' cannot be zero".

 *
 * Solved By: STEM Loyola Team
 *     Email: stemloyola@gmail.com
 *     Form : N/A
 *    Stream: N/A
*/

#include<iostream>
#include<cmath>       // abs()

#define INFINITESIMAL 0.000001   // Assume any value less than this is zero

using namespace std;

int main(){
    // Ask the user for the values of coefficients
    float a, b, c;

    cout << "Quadratic equation: a^2 + bx + c = 0 and 'a' is not zero" << endl;
    cout << "Enter value of \"a\": "; cin >> a;
    cout << "Enter value of \"b\": "; cin >> b;
    cout << "Enter value of \"c\": "; cin >> c;

    // Try to calculate the roots of the equation
    if ( abs(a) < INFINITESIMAL ) {
        // Note: Due to the way computers store decimal values, it is not ideal
        //       to compare two decimal point values using the equal sign (=).
        //       For further reading, refer to
        //       https://noobtuts.com/cpp/compare-float-values
        cout << "The value of 'a' cannot be zero" << endl;
    } else {
        float discriminant = b * b - 4 * a * c;

        if ( discriminant < 0 ) {
            cout << "No Real Solutions" << endl;
        } else {
            float x1, x2;

            x1 = (-b + sqrt(discriminant)) / (2 * a);
            x2 = (-b - sqrt(discriminant)) / (2 * a);

            cout << "Roots are " << x1 << " and " << x2 << endl;
        }
    }

    return 0;
}
